﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Windows.Forms;

namespace VirtualPrinter_Client_Sample
{
    public partial class Program
    {
        /// <summary>
        /// FileParser() puts contents of INI file on list box.
        /// </summary>
        /// <param name="PathToINI">
        /// Raw path to INI file that came from stream.
        /// </param>
        public static void FileParser(String PathToINI)
        {
            String TruncatedPathToINI;

            if (PathToINI.IndexOf((char)0) != -1)
            {
                // Deletes excessive symbols from string.
                // Usually this is done only for messages coming from named pipe.
                TruncatedPathToINI = PathToINI.Remove(PathToINI.IndexOf((char)0));
            }
            else
            {
                TruncatedPathToINI = PathToINI;
            }

            if (File.Exists(TruncatedPathToINI) == true)
            {
                using (StreamReader reader = new StreamReader(TruncatedPathToINI))
                // Reads from INI file and puts its conttents into list box on the screen.
                {
                    String line;
                    while ((line = reader.ReadLine()) != null)
                    {
                        mainform.listBox.Items.Add(line);
                    }
                }
            }
            else
            {
                MessageBox.Show("Cannot find the file: \n" + TruncatedPathToINI);
            }
        }

    }
}
