﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace VirtualPrinter_Client_Sample
{
    public partial class MainForm
    {
        private const int WM_COPYDATA = 0x004A;
        private struct COPYDATASTRUCT
        {
            public IntPtr dwData;
            public int cbData;
            [MarshalAs(UnmanagedType.LPWStr)]
            public string lpData;
        }

        /// <summary>
        /// Overriding of standard method which catches messages from system.
        /// </summary>
        /// <param name="m">Message that came to application.</param>
        [System.Security.Permissions.PermissionSet(System.Security.Permissions.SecurityAction.Demand, Name = "FullTrust")]
        protected override void WndProc(ref Message m)
        {
            switch (m.Msg)
            {
                case WM_COPYDATA:
                    COPYDATASTRUCT mystr = new COPYDATASTRUCT();
                    Type mytype = mystr.GetType();
                    mystr = (COPYDATASTRUCT)m.GetLParam(mytype);
                    Program.PathToINI = mystr.lpData;
                    
                    // We want to extract only messages which match Message id.
                    if ((long)mystr.dwData == Program.MessageID)
                    {
                        MessageBox.Show("Path has been received through WM_COPYDATA message: \n" + mystr.lpData);
                        Program.FileParser(Program.PathToINI); // Method for parsing the INI file.
                    }
                    break;
            }

            base.WndProc(ref m);
        }
    }
}
